package it.unibas.mastermind.modello;

public class Partita {
    
    private Combinazione combinazione;
    private Valutatore valutatore;
    private boolean conclusa;
    private java.util.List listaTentativi = new java.util.ArrayList();
    private java.util.List listaRisposte = new java.util.ArrayList();
    
    public Partita() {
        this.combinazione = new Combinazione();
        combinazione.genera();
        this.valutatore = new Valutatore();
    }
    
    public boolean isConclusa() {
        return conclusa;
    }
    
    public Combinazione getCombinazione() {
        return this.combinazione;
    }
    
    public Risposta verificaTentativo(Combinazione tentativo) {
        if (this.isConclusa()) {
            throw new IllegalStateException("Partita conclusa");
        }
        listaTentativi.add(tentativo);
        Risposta risposta = valutatore.valuta(this.combinazione, tentativo);
        listaRisposte.add(risposta);
        if (risposta.getPalliniNeri() == 4) {
            conclusa = true;
        }
        return risposta;
    }

    public Combinazione getTentativo(int i) {
        assert(0 <= i && i < numeroTentativi()) : "Tentativo inesistente";
        return (Combinazione)listaTentativi.get(i);
    }

    public Risposta getRisposta(int i) {
        assert(0 <= i && i < numeroTentativi()) : "Tentativo inesistente";
        return (Risposta)listaRisposte.get(i);
    }

    public int numeroTentativi() {
        return listaTentativi.size();
    }
}
