package it.unibas.mastermind.modello;

public class Valutatore {
    
    public Risposta valuta(Combinazione nascosta, Combinazione tentata) {
        Risposta risposta = new Risposta();
        risposta.setPalliniNeri(calcolaPalliniNeri(nascosta, tentata));
        risposta.setPalliniBianchi(calcolaPalliniBianchi(nascosta, tentata));
        return risposta;
    }
    
    private int calcolaPalliniNeri(Combinazione nascosta, Combinazione tentata) {
        int pallini = 0;
        for (int i = 0; i < Combinazione.CIFRECOMBINAZIONE; i++) {
            if (nascosta.getCifra(i) == tentata.getCifra(i)) {
                pallini++;
            }
        }
        return pallini;
    }

    private int calcolaPalliniBianchi(Combinazione nascosta, Combinazione tentata) {
        int pallini = 0;
        for (int i = 0; i < Combinazione.CIFRECOMBINAZIONE; i++) {
            if (nascosta.getCifra(i) != tentata.getCifra(i)) {
                if (contiene(nascosta, tentata.getCifra(i))) {
                    pallini++;
                }
            }
        }
        return pallini;        
    }
    
    private boolean contiene(Combinazione combinazione, int cifra) {
        for (int i = 0; i < Combinazione.CIFRECOMBINAZIONE; i++) {
            if (combinazione.getCifra(i) == cifra) {
                return true;
            }
        }
        return false;
    }
}
