package it.unibas.mastermind.test;

import it.unibas.mastermind.modello.Combinazione;
import it.unibas.mastermind.modello.Risposta;
import it.unibas.mastermind.modello.Valutatore;
import junit.framework.*;

public class TestValutatore extends TestCase {
    
    private Valutatore valutatore;
    
    public TestValutatore(String name) {
        super(name);
        //Logger.setLevel(java.util.logging.Level.FINE);
    }

    protected void setUp() throws java.lang.Exception {
        valutatore = new Valutatore();
    }

    protected void tearDown() throws java.lang.Exception {
    }
    
    public void testValuta1() {
        Combinazione nascosta = fabbricaComb(1, 2, 3, 4);
        Combinazione tentata = fabbricaComb(1, 2, 3, 4);
        Risposta risposta = valutatore.valuta(nascosta, tentata);
        Assert.assertEquals("neri", 4, risposta.getPalliniNeri());
        Assert.assertEquals("bianchi", 0, risposta.getPalliniBianchi());
    }
    
    public void testValuta2() {
        Combinazione nascosta = fabbricaComb(2, 4, 6, 1);
        Combinazione tentata = fabbricaComb(1, 6, 2, 4);
        Risposta risposta = valutatore.valuta(nascosta, tentata);
        Assert.assertEquals("neri", 0, risposta.getPalliniNeri());
        Assert.assertEquals("bianchi", 4, risposta.getPalliniBianchi());
    }

    public void testValuta3() {
        Combinazione nascosta = fabbricaComb(2, 4, 6, 1);
        Combinazione tentata = fabbricaComb(2, 1, 6, 4);
        Risposta risposta = valutatore.valuta(nascosta, tentata);
        Assert.assertEquals("neri", 2, risposta.getPalliniNeri());
        Assert.assertEquals("bianchi", 2, risposta.getPalliniBianchi());
    }

    public void testValuta4() {
        Combinazione nascosta = fabbricaComb(6, 2, 5, 1);
        Combinazione tentata = fabbricaComb(2, 3, 4, 1);
        Risposta risposta = valutatore.valuta(nascosta, tentata);
        Assert.assertEquals("neri", 1, risposta.getPalliniNeri());
        Assert.assertEquals("bianchi", 1, risposta.getPalliniBianchi());
    }

    public void testValuta5() {
        Combinazione nascosta = fabbricaComb(1, 2, 3, 4);
        Combinazione tentata = fabbricaComb(5, 6, 1, 2);
        Risposta risposta = valutatore.valuta(nascosta, tentata);
        Assert.assertEquals("neri", 0, risposta.getPalliniNeri());
        Assert.assertEquals("bianchi", 2, risposta.getPalliniBianchi());
    }

    private Combinazione fabbricaComb(int c1, int c2, int c3, int c4) {
        Combinazione comb = new Combinazione();
        comb.setCifra(0, c1);
        comb.setCifra(1, c2);
        comb.setCifra(2, c3);
        comb.setCifra(3, c4);
        return comb;
    }

}
